/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code in this file as it was released upon
 * April 1, 2001 and that is NOT a joke!
 *
 * The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
 * all Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001-2002
 * by Henk-Johan van Rantwijk. All Rights Reserved.
 *
 * Contributor(s): 
 *
 *  Brian King  <BrianK@ActiveState.com> 
 *  HJ van Rantwijk  <Bugs4HJ@NetScape.net> 
 *  Neil Pryde <NeilPryde92651@netscape.net>
 *  Roger Keays <rogerk@ieee.org>
 *  Huijing Zhou <hj@cip.wiwi.uni-karlsruhe.de>
 *  Raj Bhaskar <r.bhaskar@compserv.gla.ac.uk>
*/

const G_VER             = "1.1.30";
const G_MSG             = "MultiZilla " + G_VER + " Beta 2";
const G_NAME            = "multiviews";

const G_NEED_BUILD      = 2002101708;
const G_NEED_BUILD_4MAC = 2002101708;

const G_CHROME          = "chrome";
const G_DEFAULTS        = "defaults";
const G_PREFS           = "Preferences";
const G_PROGRAM         = "program";
const G_COMPONENTS      = "components";
const G_CONTENT         = "content/multiviews/";

/* see bug: http://mozdev.org/bugs/show_bug.cgi?id=1918 */
const G_MODERN_SKIN     = "skin/modern/multiviews/";
const G_CLASSIC_SKIN    = "skin/classic/multiviews/";

const G_LOCALE          = "locale/en-US/multiviews/";
const G_JAR_FILE        = "multiviews.jar";
const G_PREF_FILE       = "all-mz.js";
const G_LOCALSTORE_FILE = "localstore.rdf";
const G_UPDATENOTIFIER  = "mzUpdateNotifier.js";

const G_CHROME_DIR      = getFolder(G_CHROME);
const G_PROGRAM_DIR     = getFolder(G_PROGRAM);
const G_COMPONENTS_DIR  = getFolder(G_COMPONENTS);
const G_DEFPREF_DIR     = getFolder(G_PROGRAM, "defaults/pref");
const G_DEFPROFILE_DIR  = getFolder(G_PROGRAM, "defaults/profile");
const G_PREFS_DIR       = getFolder("profile");
const MultiViewsFile    = getFolder(G_CHROME_DIR, G_JAR_FILE);
const G_COMPREG         = getFolder(G_PROGRAM, "components/compreg.dat");
const G_COMPONENTREG    = getFolder(G_PROGRAM, "component.reg");

const COMNT_1           = "Installation of " + G_MSG;
const COMNT_2           = "MultiZilla's jar file";
const COMNT_3           = "Mozilla version to old for this version of MultiZilla: Aborting Installation";
const COMNT_4           = "MultiZilla's default preference settings";
const COMNT_5           = "MultiZilla's replacement for localstore.rdf";
const COMNT_6           = "MultiZilla's Update Notifier";

var err = initInstall(G_MSG, G_NAME, G_VER);
var platformStr;
var platformNode;
var abort = false;

logComment(COMNT_1);
logComment("initInstall: " + err);

  if (!err)
    err = "Ok";
  logComment( "Installation init : " + err );
  // select used platform
  if ('platform' in Install) {
    platformStr = new String( Install.platform );

    if (!platformStr.search(/^Macintosh/))
      platformNode = 'mac';
    else if (!platformStr.search(/^Win/))
      platformNode = 'win';
    else
      platformNode = 'unix';
  }
  else {
    var fOSMac  = getFolder( "Mac System" );
    var fOSWin  = getFolder( "Win System" );

    logComment( "fOSMac: "  + fOSMac );
    logComment( "fOSWin: "  + fOSWin );

    if (fOSMac != null)
      platformNode = 'mac';
    else if (fOSWin != null)
      platformNode = 'win';
    else
      platformNode = 'unix';
  }
  // only install if we have a compatible version of Mozilla
  if (platformNode == 'mac' && buildID < G_NEED_BUILD_4MAC) {
    G_NEED_BUILD = G_NEED_BUILD_4MAC
    abort = true;
  }
  else if (buildID < G_NEED_BUILD) // Windows/Unix/Linux
    abort = true;
  if (abort) {
    alert("Aborting this " + COMNT_1 + 
          "\n\nYou need Mozilla {Build ID: " + G_NEED_BUILD + "} for this installation\n" +
          "but you are using Mozilla {Build ID:" + buildID + "} instead.\n" + 
          "Visit www.mozilla.org and install a recent mozilla build!");
    logComment(COMNT_3);
    cancelInstall();
  }
  else {
    ///////////////////////////////////////////////////////////////
    // MultiZilla's 'Update Notifications' needs to be registered
    // and this doesn't seem to work for older mozilla builds.
    // We just wack the registry, to make sure it gets registered!
    ///////////////////////////////////////////////////////////////
    if (File.exists(G_COMPREG))
      File.remove(G_COMPREG);
    else File.remove(G_COMPONENTREG);

    addFile( COMNT_2, G_JAR_FILE, G_CHROME_DIR, "" );
    addFile( COMNT_4, G_PREF_FILE, G_DEFPREF_DIR, "" );
    ///////////////////////////////////////////////////////////////
    // workaround for: http://mozdev.org/bugs/show_bug.cgi?id=1967
    // replace localstore.rdf for new MultiZilla installation only!
    ///////////////////////////////////////////////////////////////
    if (!File.exists(MultiViewsFile))
      addFile( COMNT_5, G_LOCALSTORE_FILE, G_PREFS_DIR, "" );
    addFile( COMNT_5, G_LOCALSTORE_FILE, G_DEFPROFILE_DIR, "" );
    addFile( COMNT_6, G_UPDATENOTIFIER, G_COMPONENTS_DIR, "" );

    if (platformNode == 'win')
      logComment("Installation started for Win32 platform");
    else 
      logComment("Installation started for a *nix/Mac platform");
    registerChrome(CONTENT | DELAYED_CHROME, getFolder(G_CHROME, G_JAR_FILE), G_CONTENT);
    registerChrome(SKIN    | DELAYED_CHROME, getFolder(G_CHROME, G_JAR_FILE), G_MODERN_SKIN);
    registerChrome(SKIN    | DELAYED_CHROME, getFolder(G_CHROME, G_JAR_FILE), G_CLASSIC_SKIN);
    registerChrome(LOCALE  | DELAYED_CHROME, getFolder(G_CHROME, G_JAR_FILE), G_LOCALE);
 
    err = getLastError();

    if (err == SUCCESS)
      performInstall();
    else {
      logComment("Detailed information can be found at: http://devedge.netscape.com/library/manuals/2001/xpinstall/1.0/err.html#998941");
      cancelInstall(err);
    }
  } // wrong build ID used

